'use strict';

var _unexpectedHtmllikeRawAdapter = require('unexpected-htmllike-raw-adapter');

var _unexpectedHtmllikeRawAdapter2 = _interopRequireDefault(_unexpectedHtmllikeRawAdapter);

var _unexpectedHtmllikeJsxAdapter = require('unexpected-htmllike-jsx-adapter');

var _unexpectedHtmllikeJsxAdapter2 = _interopRequireDefault(_unexpectedHtmllikeJsxAdapter);

var _unexpectedHtmllikeReactrenderedAdapter = require('unexpected-htmllike-reactrendered-adapter');

var _unexpectedHtmllikeReactrenderedAdapter2 = _interopRequireDefault(_unexpectedHtmllikeReactrenderedAdapter);

var _snapshots = require('../helpers/snapshots');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function installInto(expect) {

  var rawAdapter = new _unexpectedHtmllikeRawAdapter2.default({ convertToString: true, concatTextContent: true });
  var shallowAdapter = new _unexpectedHtmllikeJsxAdapter2.default({ convertToString: true, concatTextContent: true });
  var renderedReactAdapter = new _unexpectedHtmllikeReactrenderedAdapter2.default({ convertToString: true, concatTextContent: true });
  expect.addAssertion('<ReactShallowRenderer> to [exactly] match snapshot [with all children] [with all wrappers]', function (expect, subject) {
    (0, _snapshots.compareSnapshot)(expect, this.flags, rawAdapter.convertFromOther(shallowAdapter, subject));
  });

  // TODO: events!
  expect.addAssertion('<RenderedReactElement> to [exactly] match snapshot [with all children] [with all wrappers]', function (expect, subject) {
    (0, _snapshots.compareSnapshot)(expect, this.flags, rawAdapter.convertFromOther(renderedReactAdapter, subject));
  });
}

module.exports = { installInto: installInto };